// lientMgmt.h: interface for the ClientMgmt class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIENTMGMT_H__DBB4D610_E3EF_4182_BADD_31C1E48DF225__INCLUDED_)
#define AFX_LIENTMGMT_H__DBB4D610_E3EF_4182_BADD_31C1E48DF225__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//STL list ϱ ؼ...
#include <list>
#include "WMIMgnt.h"

using namespace std;

/******************************************************************************************

class CBaseThread  
	  ϰ ϱ 

private:
	CBaseThread(const CBaseThread &self)
Def	:  ε
Pre	:
Post:

	CBaseThread& operator=(const CBaseThread &self);
Def	: Կ ۷
Pre	:
Post:

	static DWORD WINAPI ThreadFun(void *lpvParam)
Def	: Լ
Pre	:
Post: Run() 
	
	HANDLE hThread_		//  ڵ

  
public:
	CBaseThread() {};
Def	: ⺻
Pre	:
Post:

	virtual ~CBaseThread() {};
Def	: Ҹ
Pre	:
Post:

	virtual void Start()
	{
		hThread_ = reinterpret_cast<HANDLE> (CreateThread(NULL, NULL,CBaseThread::ThreadFun,
												this, NULL, NULL));
	} 
Def	: Լ
Pre	:
Post: hThread_  ڵ 

	
	virtual void Join(DWORD dwMilliseconds = INFINITE)
    {
		WaitForSingleObject(hThread_, dwMilliseconds);
	} 
Def	:
Pre	:
Post:

	
	virtual HANDLE GetThreadHandle() { return hThread_; }
Def	: ڵ 
Pre	:
Post:

	
	virtual void Run() = 0; 
Def	: Լ
Pre	:
Post:

	

******************************************************************************************/
class CBaseThread  
{
public:
	CBaseThread() {};
	virtual ~CBaseThread() {};
	
private:
	CBaseThread(const CBaseThread &self);
	CBaseThread& operator=(const CBaseThread &self);
	
public:
	virtual void Start()
	{
		hThread_ = reinterpret_cast<HANDLE> (CreateThread(NULL, NULL,CBaseThread::ThreadFun,
												this, NULL, NULL));
	} 
	
	virtual void Join(DWORD dwMilliseconds = INFINITE)
    {
		WaitForSingleObject(hThread_, dwMilliseconds);
	} 
	
	virtual HANDLE GetThreadHandle() { return hThread_; }
	
	virtual void Run() = 0; 
	
private:
	static DWORD WINAPI ThreadFun(void *lpvParam)
	{
		CBaseThread *pThis = static_cast<CBaseThread*>(lpvParam);
		pThis->Run();
		return NULL;
	} 
	
	HANDLE hThread_; 
	
};



/******************************************************************************************

class ClientMgmt : CBaseThread
	Ŭ̾Ʈ Ŭ

  
private:
	list<ExeFileInfo>		m_exefileList	//  Ʈ
	HANDLE Mutex_MessageQueue				// ܼȭ ۾ ȭ ϴ ؽ


public:
	ClientMgmt()
Def	: ⺻
Pre	:
Post:

	virtual ~ClientMgmt()
Def	: Ҹ
Pre	:
Post:

	bool VerifyChar(char input[], int Type)
Def	: ڿ ˻
Pre	: 
		char input[]: ˻ ڿ
		int Type	: ˻ Ÿ (1: ð, 2: ϸ, 3: )

Post:  ˿ ´ Ȯ. ˿  true, ȸ false 


	bool ExecuteManager()
Def	: ExecuteManager
Pre	:
Post:  Ʈ  α׷  ð ų .  α (log.txt) 

	bool VerifyManager(PMSG_INFO info)
Def	: Verify Manager
Pre	: PMSG_INFO info	: ޼
Post: ޼  ˿ ´ Ȯ  ̸ ϸƮ ϰ  OK޼ . ̸   û

	SOCKET ReteriveSock()
Def	: ڽ  
Pre	:
Post:

	VOID			HandlerThreadRun()
Def	: ThreadFun() Լ.
Pre	:
Post: Sleep() millisecond ֱ ť Ͱ ԵǾ ٸ, Ͱ ԵǾٸ Ŭ̾Ʈ ڵ鷯Լ Ų.
	  ֱ ǻ ¸  Ѵ.

	BOOL			Connect()
Def	:   
Pre	:
Post: ӿ ϸ hThread_ ڵ ϰ true, ϸ false 

	BOOL			CreateClient(char* ServerIP, UINT port, CLIENTHANDLER proc)
Def	: Ŭ̾Ʈ  
Pre	:	char* ServerIP		:  IP
		UINT port			:  Port
		CLIENTHANDLER proc	: m_proc  Լ
Post: Ŭ̾Ʈ  ,  ϰ true . Է   false 

	VOID			PutData( char Command, SOCKET socket, char* pData, int DataSize )
Def	: Message Queue Manager
Pre	:	char Command	: Ŀǵ
		SOCKET socket	: 
		char* pData		: 빮ڿ
		int DataSize	: 빮ڿ

Post: Է ޼ť 

	VOID			Send(char command, char *pData, int nSize)
Def	: Transfer Manager
Pre	:	char command	: Ŀǵ
		char *pData		: 빮ڿ
		int nSize		: 빮ڿ
Post:   Ѵ

	virtual VOID	ClientHandler(PMSG_INFO pInfo) {};
Def	: Լ
Pre	:
Post:


protected:
	void Run();
Def	: Ŭ̾Ʈ Լ ThreadFun() Լ. 
Pre	:
Post: κ  ٸ.
	  ۹ ޼ ޼ť Ѵ.

	static DWORD WINAPI ThreadFun(void *lpvParam)
Def	: Ŭ̾Ʈ Լ
Pre	:
Post:  Լ 


	BOOL				m_isDead	// Ŭ̾Ʈ ۵θ ϴ ÷
	SOCKET				m_Sock		// 
	SOCKADDR_IN			m_cliAddr	// ּ
	CLIENTHANDLER		m_proc		// ޼ óԼ Լ
	list<PMSG_INFO>		m_msgQueue	// ó ޼ 
};


******************************************************************************************/

class ClientMgmt : CBaseThread
{
private:
	list<ExeFileInfo>		m_exefileList;		// Ʈ
	HANDLE Mutex_MessageQueue;


public:
	ClientMgmt();
	virtual ~ClientMgmt();

public:
	bool VerifyChar(char input[], int Type);

	bool ExecuteManager();
	bool VerifyManager(PMSG_INFO info);
	SOCKET ReteriveSock();
	VOID			HandlerThreadRun();
	BOOL			Connect();
	BOOL			CreateClient(char* ServerIP, UINT port, CLIENTHANDLER proc);
	VOID			PutData( char Command, SOCKET socket, char* pData, int DataSize );
	VOID			Send(char command, char *pData, int nSize);
	virtual VOID	ClientHandler(PMSG_INFO pInfo) {};

protected:
	void Run();

protected:
	static DWORD WINAPI ThreadFun(void *lpvParam)
	{
		ClientMgmt *pThis = static_cast<ClientMgmt*>(lpvParam);
		pThis->HandlerThreadRun();
		return NULL;
	} 

protected:
	BOOL				m_isDead;
	SOCKET				m_Sock;
	SOCKADDR_IN			m_cliAddr;
	CLIENTHANDLER		m_proc;
	list<PMSG_INFO>		m_msgQueue; //  Queue Manager  ϴ Ŭ̴.


};

#endif // !defined(AFX_LIENTMGMT_H__DBB4D610_E3EF_4182_BADD_31C1E48DF225__INCLUDED_)
