// ServerMgmt.h: interface for the Server class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SERVER1_H__AD2C7558_931B_405D_B382_39AF0EDE742A__INCLUDED_)
#define AFX_SERVER1_H__AD2C7558_931B_405D_B382_39AF0EDE742A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//STL list ϱ ؼ...
#include <list>
#include <windows.h>
#include <stdio.h>


using namespace std;


////////////////////////////////////////////////////////////////////////////////////////
// Windows Thread Class · ... Java Thread ϰ ϰ  ؼ
// ..
////////////////////////////////////////////////////////////////////////////////////////


/******************************************************************************************

class CBaseThread  
	  ϰ ϱ 

private:
	CBaseThread(const CBaseThread &self)
Def	:  ε
Pre	:
Post:

	CBaseThread& operator=(const CBaseThread &self);
Def	: Կ ۷
Pre	:
Post:

	static DWORD WINAPI ThreadFun(void *lpvParam)
Def	: Լ
Pre	:
Post: Run() 
	
	HANDLE hThread_		//  ڵ

  
public:
	CBaseThread() {};
Def	: ⺻
Pre	:
Post:

	virtual ~CBaseThread() {};
Def	: Ҹ
Pre	:
Post:

	virtual void Start()
	{
		hThread_ = reinterpret_cast<HANDLE> (CreateThread(NULL, NULL,CBaseThread::ThreadFun,
												this, NULL, NULL));
	} 
Def	: Լ
Pre	:
Post: hThread_  ڵ 

	
	virtual void Join(DWORD dwMilliseconds = INFINITE)
    {
		WaitForSingleObject(hThread_, dwMilliseconds);
	} 
Def	:
Pre	:
Post:

	
	virtual HANDLE GetThreadHandle() { return hThread_; }
Def	: ڵ 
Pre	:
Post:

	
	virtual void Run() = 0; 
Def	: Լ
Pre	:
Post:

	

******************************************************************************************/

class CBaseThread  
{
public:
	CBaseThread() {};
	virtual ~CBaseThread() {};

private:
	CBaseThread(const CBaseThread &self);
	CBaseThread& operator=(const CBaseThread &self);
	
public:
	
	// 带 Ѵ.
	// CBaseThread::ThreadFun : Լ
	// this :   ۾ 
	virtual void Start()
	{
		hThread_ = reinterpret_cast<HANDLE> (CreateThread(NULL, NULL,CBaseThread::ThreadFun,
												this, NULL, NULL));
	} 
	
	virtual void Join(DWORD dwMilliseconds = INFINITE)
    {
		WaitForSingleObject(hThread_, dwMilliseconds);
	} 
	
	virtual HANDLE GetThreadHandle() { return hThread_; }
	
	virtual void Run() = 0; 
	
private:
	static DWORD WINAPI ThreadFun(void *lpvParam)
	{
		CBaseThread *pThis = static_cast<CBaseThread*>(lpvParam);
		pThis->Run();
		return NULL;
	} 
	
	HANDLE hThread_; 
	
};




//  Ʈ 
struct ExeFileInfo
{
	int index;					// ε
	char*	m_time;				// ð
	char*	m_excute_filename;	// ϸ
	char*	m_operation;		// operation
};

/***************************************************************************************************
class ServerMgmt : public CBaseThread

   α׷ application class

public:
	ServerMgmt()
Def	: ⺻
Pre	:
Post: 

	virtual ~ServerMgmt()
Def	: Ҹ
Pre	:
Post: 

	bool MessageProcess(__msg_info input)
Def	: ޼ť   
Pre	:
Post: 

	bool VerifyChar(char input[], int Type)
Def	: ڿ ˻
Pre	: 
		char input[]: ˻ ڿ
		int Type	: ˻ Ÿ (1: ð, 2: ϸ, 3: )

Post:  ˿ ´ Ȯ. ˿  true, ȸ false 

	bool ModifyClient(__msg_info input)
Def	: Ŭ̾Ʈ 
Pre	:	__msg_info input: Ŭ̾Ʈ   ޼ ü
Post: input ġϴ Ŭ̾Ʈ ãƼ  

	bool TransferExeInfo(SOCKET iClientSocket, int Sign)
Def	: Transfer Manager
Pre	:	SOCKET iClientSocket: Ŭ̾Ʈ 
		int Sign			: Ŭ̾Ʈκ   (1: OK, 2: ۿû)
Post: Ŭ̾Ʈ 信   Ѵ.

	bool VerifyManager()
Def	: VerifyManager  
Pre	: data.txt 
Post: 
		˿ ´ٸ  Ʈ ߰, true 
		˰ Ʋ Ͱ ִٸ false 

	BOOL			CreateServer(UINT nPort, SERVERHANDLER proc)
Def	:   Ű     Ǿ ϴ ޼ҵ
Pre	: 
		nPort : ۵  Ʈȣ
		proc :   Ǵ ڵ鷯 Լ Լ 
Post: μ ʱȭ.  Լ .

	BOOL			WaitClient()
Def	: Ŭ̾Ʈ  ٸ
Pre	:
Post: Ŭ̾Ʈ  ٸ Լμ accept Ŭ̾Ʈ  ̷  Block ° ȴ.

	int				GetClientLength()
Def	: 
Pre	:
Post:  Ŭ̾Ʈ (=Ŭ̾Ʈť ) 


	VOID			PutData( char Command, SOCKET socket, char* pData, int DataSize)
Def	: Message Queue Manager
Pre	:	char Command	: Ŀǵ
		SOCKET socket	: 
		char* pData		: 빮ڿ
		int DataSize	: 빮ڿ

Post: Է ޼ť 

	VOID			ClientAccept()
Def	:  Ŭ̾Ʈ   
Pre	:
Post: 

	VOID			ClientThreadRun()
Def	: Message-Queue Manager
Pre	:
Post: Ŭ̾Ʈκ  Ϳ ؼ ٷ ť .

	
	VOID			Send(SOCKET sock, char command, char* pData, int nSize)
Def	: Ŭ̾Ʈ ޼ 
Pre	: 
		char Command:	Ŀǵ
		SOCKET socket:	
		char* pData:	
		int DataSize:	

Post: Է¹  Ŭ̾Ʈ ޼ Ѵ.

	virtual VOID	ServerHandler(__msg_info info) {};
Def	:  Լ
Pre	:
Post: 

	
protected:
	VOID Run();
Def	: Լ.
Pre	: 
Post: ClientThreadRun Ͽ Ŭ̾Ʈ  Ͽ ޾ƿ´.

	static DWORD WINAPI ThreadFun(void *lpvParam)
Def	:   Լ
Pre	:
Post:  Լ 


	list<__client_info>		m_clientQueue		//ӵ Ŭ̾Ʈ   ϱ  ť.
	list<__msg_info>		m_msgQueue			//Ŭ̾Ʈκ  ͸ ϱ  ť
	SOCKET					m_ServerSock		// 
	BOOL					m_isDead			//ֿ  ¸ .
	SERVERHANDLER			m_fnHandler			//ڿ  ϵǴ ڵ鷯 Լ 

  
private:
	int ClientIndex								// Ŭ̾Ʈ ȣ
	HANDLE Mutex_ClientQueue					// Ŭ̾Ʈť  ؽ
	HANDLE Mutex_MessageQueue					// ޼ť  ؽ
	HANDLE Mutex_Print							// ܼȭ  ؽ
	list<ExeFileInfo>		m_exefileList		// Ʈ

***************************************************************************************************/





class ServerMgmt : public CBaseThread
{
public:
	ServerMgmt();
	virtual ~ServerMgmt();


//method
public:	
	bool MessageProcess(__msg_info input);

	bool VerifyChar(char input[], int Type);
	bool ModifyClient(__msg_info input);
	bool TransferExeInfo(SOCKET iClientSocket, int Sign);
	bool VerifyManager();
	BOOL			CreateServer(UINT nPort, SERVERHANDLER proc);
	BOOL			WaitClient();
	//  Ŭ̾Ʈ (=Ŭ̾Ʈť ) 
	int				GetClientLength() { return m_clientQueue.size(); }

	// ޼ť ͸ 
	VOID			PutData( char Command, SOCKET socket, char* pData, int DataSize);
	VOID			ClientAccept();
	VOID			ClientThreadRun();
	
	// Ŭ̾Ʈ ٷ  
	VOID			Send(SOCKET sock, char command, char* pData, int nSize);
	virtual VOID	ServerHandler(__msg_info info) {};
	
protected:
	VOID Run();

protected:

	/* 
	Def	: Լ.
	Pre	: 
	Post: ClientThreadRun Ͽ Ŭ̾Ʈ  Ͽ ޾ƿ´.
	*/
	static DWORD WINAPI ThreadFun(void *lpvParam)
	{
		ServerMgmt *pThis = static_cast<ServerMgmt*>(lpvParam);
		pThis->ClientThreadRun();
		return NULL;
	} 

protected:
	list<__client_info>		m_clientQueue;		//ӵ Ŭ̾Ʈ   ϱ  ť.
	
	list<__msg_info>		m_msgQueue;			//Ŭ̾Ʈκ  ͸ ϱ  ť
	SOCKET					m_ServerSock;		// 
	BOOL					m_isDead;			//ֿ  ¸ .
	SERVERHANDLER			m_fnHandler;		//ڿ  ϵǴ ڵ鷯 Լ 
private:
	int ClientIndex;	// Ŭ̾Ʈ ȣ

	HANDLE Mutex_ClientQueue;
	HANDLE Mutex_MessageQueue;
	HANDLE Mutex_Print;
	list<ExeFileInfo>		m_exefileList;		// Ʈ
};




#endif // !defined(AFX_SERVER1_H__AD2C7558_931B_405D_B382_39AF0EDE742A__INCLUDED_)










